package local;

import java.rmi.*;
import java.net.*;
import java.io.*;
import java.rmi.server.*;

import service.TimeServer;

public class LocalServer implements TimeServer, java.io.Serializable {
    static final long serialVersionUID = -1723714162577719834L;

    private String location = null;

    public LocalServer(String location) {
//        System.out.println("LocalServer instantiated");
        this.location = location;
    }

    public LocalServer() {
        this(null);
    }

    public String getText() {
        try {
            DataInputStream dis = new DataInputStream((InputStream) new URL(location).getContent());
            return dis.readLine();
        } catch (Exception e) {
            System.out.println("Couldn't get text: " + e.getMessage());
        }
        return "No text found/specified";
    }

    public String getHost() {
        try {
            return InetAddress.getLocalHost().getHostName();
        } catch (java.net.UnknownHostException e) {
            return "Unkown Hostname";
        }
    }
    public long getTime() {
        return System.currentTimeMillis();
    }
}
