package local;

import net.jini.discovery.*;
import net.jini.core.lookup.*;
import net.jini.lookup.entry.*;
import net.jini.core.entry.*;
import com.sun.jini.lookup.*;
import com.sun.jini.lease.*;
import java.rmi.*;

import service.TimeServer;

public class LocalSetup implements ServiceIDListener {
        static JoinManager jm = null;
        public static void main(String args[]) throws Exception {
                TimeServer ds;

                // A must or we won't be able to access the registrar classes
                System.setSecurityManager(new RMISecurityManager());

//                System.out.println("Creating entry classes:");
                Name nameEntry = new Name("Local Time Server");
                ServiceInfo serviceEntry = new ServiceInfo("Local Time Service", "Eran Davidov", "SMI", "0.1", "Local XVL", "1");
                Entry entries[] = new Entry[] {nameEntry, serviceEntry};

                if (args.length != 0)
                    ds = new LocalServer(args[0]);
                else
                    ds = new LocalServer();

//                jm = new JoinManager(ds, entries, new LocalSetup(), new LeaseRenewalManager());

// manual registration

                LookupDiscovery ld = new LookupDiscovery(new String[0]);
                System.out.println("Adding listener");
                ld.addDiscoveryListener(new TListener());
                ld.setGroups(LookupDiscovery.ALL_GROUPS);
        
                serviceItem = new ServiceItem(null, ds, entries);

                Thread.currentThread().sleep(1000000000L);
        }

        public void serviceIDNotify(ServiceID sid) {
            System.out.println("Got Service ID: " + sid);
        }


        public static ServiceItem serviceItem = null;

        public static void dumpRegistrar(ServiceRegistrar reg)
            throws RemoteException, NoSuchFieldException {
                System.out.println("Registrar " + reg.getLocator().toString());
                ServiceRegistration sr = reg.register(serviceItem, 2 * 60 * 1000);
                System.out.println("Registered with ID " + sr.getServiceID());

        }



}

class TListener implements DiscoveryListener {
                        public void discovered(DiscoveryEvent e) {
                                dumpEvent("discovered: ", e);
                        }

                        public void discarded(DiscoveryEvent e) {
                                dumpEvent("discarded: ", e);
                        }

                        public void dumpEvent(String s, DiscoveryEvent e) {
                                try {
                                        System.out.println(s);
                                        ServiceRegistrar regs[] = e.getRegistrars();
                                        for (int i = 0; i < regs.length; i++) {
                                                LocalSetup.dumpRegistrar(regs[i]);
                                        }
                                } catch (Exception z) {
                                        System.out.println("Caught ex " + z.getMessage());
                                        z.printStackTrace();
                                }
                        }
}

