package proxy;

import java.rmi.*;
import java.net.*;
import java.rmi.server.*;
import com.sun.jini.lookup.*;
import com.sun.jini.lease.*;
import net.jini.core.entry.*;
import net.jini.core.lookup.*;
import net.jini.lookup.entry.*;
import net.jini.discovery.*;

import service.TimeServer;
import remote.*;

public class RegisterProxy  {

    // name under which to register in the rmiregistry
    static final String serviceName = "remote.TimeServerImpl";

    static JoinManager jm;

    // The proxy we'll transfer to clients
    static TimeServer serviceProxy;

    // The running server
    static TimeServerImpl serviceImpl;

    // URL under which we registered in the rmiregistry
    static String registeredName = null;

    static ServiceItem serviceItem;

    public static void main(String args[]) throws Exception {
    
        // install a security manager for RMI's sake
        System.setSecurityManager(new RMISecurityManager());


        // prepare
        registeredName = InetAddress.getLocalHost().getHostName();

        // instantiate a server object with he text passed to the user
        serviceImpl = new TimeServerImpl(args[0]);

        System.out.println("Registering server with rmiregistry");
        Naming.rebind("//localhost/" + serviceName, serviceImpl);


        registeredName = "//" + registeredName + "/" + serviceName;

        // mow create proxy and advertise it around
        serviceProxy = new TimeServerProxy(registeredName);

        Name nameEntry = new Name("Proxy Time Server");
        ServiceInfo serviceInfo = new ServiceInfo("Proxy Time Service", "Eran Davidov", "SMI", "0.1", "Generic Proxy", "1");
        Entry entries[] = new Entry[] {nameEntry, serviceInfo};

        System.out.println("Registering server with lookup service");
        jm = new JoinManager(serviceProxy, entries, (ServiceIDListener) serviceImpl, new LeaseRenewalManager());
    }



}

