package proxy;

import java.io.*;
import java.rmi.*;
import java.net.*;
import java.rmi.server.*;

import service.TimeServer;
import remote.*;


public class TimeServerProxy implements TimeServer, java.io.Serializable {

    // keeper of the server stub
    transient RemoteTimeServer server = null;

    // where is the service registered?
    String serviceLocation = null;

    static final long serialVersionUID = 7471069187532416589L;

    public TimeServerProxy() throws Exception {
    }


//    private void writeObject(java.io.ObjectOutputStream stream)
//        throws IOException {
//        stream.defaultWriteObject();
//    }

    // set up once we've been read by the client
    private void readObject(java.io.ObjectInputStream stream)
        throws IOException, ClassNotFoundException {

        // read all fields as usual
        stream.defaultReadObject();

        // now look for the server and get in touch with it

        try {
            Object o = Naming.lookup(serviceLocation);
//            System.out.println("Got object of type " + o.getClass().getName());
            server = (RemoteTimeServer) o;
        } catch (Exception e) {
            System.out.println("Error contacting server: " + e.getMessage());
            e.printStackTrace();
        }

//        System.out.println("TimeServerProxy created to proxy " + serviceLocation);
    }

    // this constructor is used by the registering class when...
    // ...first creatig the proxy
    TimeServerProxy(String serviceLocation) throws Exception {
        System.out.println("Prepping proxy with " + serviceLocation);
        this.serviceLocation = serviceLocation;
    }

    public String getHost() throws Exception, RemoteException {
            // just delegate on to the server
            return server.getHost();
    }


    public long getTime() throws Exception, RemoteException {
            // just delegate on to the server
        return server.getTime();
    }

    public String getText() throws Exception, RemoteException {
            // just delegate on to the server
        return server.getText();
    }

}
