package remote;

import java.rmi.*;
import java.net.*;
import java.rmi.server.*;
import com.sun.jini.lookup.*;
import com.sun.jini.lease.*;
import net.jini.core.entry.*;
import net.jini.core.lookup.*;
import net.jini.lookup.entry.*;
import net.jini.discovery.*;

import service.TimeServer;

public class RegisterTimeServer {

    static JoinManager jm;
    static RemoteTimeServer serviceImpl;
    static ServiceItem serviceItem;


    public static void main(String args[]) throws Exception {

        // install security manager so that we'll be able to talk to server
        System.setSecurityManager(new RMISecurityManager());

        // create service with text param
        serviceImpl = new TimeServerImpl(args[0]);

        Name nameEntry = new Name("True Remote Time Server");
        ServiceInfo serviceInfo = new ServiceInfo("Remote Time Service", "Eran Davidov", "SMI", "0.1", "True Remote", "1");
        Entry entries[] = new Entry[] {nameEntry, serviceInfo};

        System.out.println("Registering server with lookup service");
        jm = new JoinManager(serviceImpl, entries, (ServiceIDListener) serviceImpl, new LeaseRenewalManager());

    }


}

