package remote;

import java.rmi.*;
import java.net.*;
import java.rmi.server.*;
import com.sun.jini.lookup.*;
import com.sun.jini.lease.*;
import net.jini.core.entry.*;
import net.jini.core.lookup.*;
import net.jini.lookup.entry.*;
import net.jini.discovery.*;

import service.TimeServer;

public class TimeServerImpl extends UnicastRemoteObject
    implements RemoteTimeServer, ServiceIDListener {

    static JoinManager jm;

    private String text = null;


    public TimeServerImpl() throws RemoteException {
//        System.out.println("TimeServer created");
    }

    public TimeServerImpl(String text) throws RemoteException {
        this.text = text;
    }

    public String getHost() throws RemoteException {
        try {
            System.out.println("providing host to client");
            return InetAddress.getLocalHost().getHostName();
        } catch (java.net.UnknownHostException e) {
            return "Unkown Hostname";
        }
    }
    public long getTime() throws RemoteException {
        System.out.println("providing time to client");
        return System.currentTimeMillis();
    }

    public String getText() throws RemoteException {
        return text;
    }

    // this is so that we'd know our service ID
    public void serviceIDNotify(ServiceID sid) {
        System.out.println("Got Service ID: " + sid);
    }

}

